-- Just some code to determine how passing arguments works (when they're a table)

globaldb = {}

for i=1,10000 do

	globaldb[i] = "Foo"

end

do

	local scopedb = {}

	for i=1,10000 do

		scopedb[i] = "Foo"

	end

	function dostuff(DB)

		for i=1,1000,1 do

			DB[i] = "foo"

		end

	end

	function testpassing()

	 	local starttime,endtime,localpass,scopepass,globalpass

		local localdb = {}
		for i=1,10000,1 do

			localdb[i] = "Foo"

		end
		
	 	starttime = os.clock()

		for i=1,10000,1 do

			dostuff(localdb)

		end

	 	endtime = os.clock()
	 	localpass = endtime - starttime

	 	starttime = os.clock()

		for i=1,10000,1 do

			dostuff(scopedb)

		end

	 	endtime = os.clock()
	 	scopepass = endtime - starttime

	 	starttime = os.clock()

		for i=1,10000,1 do

			dostuff(globaldb)

		end

	 	endtime = os.clock()
	 	globalpass = endtime - starttime

	 	print("Local: " .. localpass)
	 	print("Scope: " .. scopepass)
		print("Global: " .. globalpass)
	 
	end

end

globalref = {}

for i=1,1000 do

	globalref[i] = "Foo"

end

do

	local scopedb = {}

	for i=1,1000 do

		scopedb[i] = "Foo"

	end

	function dostuffglobal()

		for i=1,1000,1 do

			globalref[i] = "Foo"

		end

	end

	function dostuffscope()

		for i=1,1000,1 do

			scopedb[i] = "Foo"

		end

	end

	function testref()

		local starttime,endtime,scopepass,globalpass

	 	starttime = os.clock()

		for i=1,10000,1 do

			dostuffscope()

		end

	 	endtime = os.clock()
	 	scopepass = endtime - starttime

	 	starttime = os.clock()

		for i=1,10000,1 do

			dostuffglobal()

		end

	 	endtime = os.clock()
	 	globalpass = endtime - starttime

	 	print("Scope: " .. scopepass)
		print("Global: " .. globalpass)

	end

end

print("Testing by passing arguments.")
testpassing()
print("Testing by reference.")
testref()